Index: palm/trunk/SOURCE/indoor_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/indoor_model_mod.f90	(revision 4645)
+++ palm/trunk/SOURCE/indoor_model_mod.f90	(revision 4646)
@@ -1,67 +1,67 @@
 !> @file indoor_model_mod.f90
-!--------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! This file is part of the PALM model system.
 !
-! PALM is free software: you can redistribute it and/or modify it under the
-! terms of the GNU General Public License as published by the Free Software
-! Foundation, either version 3 of the License, or (at your option) any later
-! version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY
-! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
-! A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with
-! PALM. If not, see <http://www.gnu.org/licenses/>.
+! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
+! Public License as published by the Free Software Foundation, either version 3 of the License, or
+! (at your option) any later version.
+!
+! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
+! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
+! Public License for more details.
+!
+! You should have received a copy of the GNU General Public License along with PALM. If not, see
+! <http://www.gnu.org/licenses/>.
 !
 ! Copyright 2018-2020 Leibniz Universitaet Hannover
 ! Copyright 2018-2020 Hochschule Offenburg
-!--------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 !
 ! Current revisions:
 ! -----------------
-! 
-! 
+!
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
-! Change order of dimension in surface array %frac to allow for better 
-! vectorization.
-! 
+! file re-formatted to follow the PALM coding standard
+!
+! 4481 2020-03-31 18:55:54Z maronga
+! Change order of dimension in surface array %frac to allow for better vectorization.
+!
 ! 4441 2020-03-04 19:20:35Z suehring
-! Major bugfix in calculation of energy demand - floor-area-per-facade was wrongly
-! calculated leading to unrealistically high energy demands and thus to
-! unreallistically high waste-heat fluxes.
-! 
+! Major bugfix in calculation of energy demand - floor-area-per-facade was wrongly calculated
+! leading to unrealistically high energy demands and thus to unreallistically high waste-heat
+! fluxes.
+!
 ! 4346 2019-12-18 11:55:56Z motisi
-! Introduction of wall_flags_total_0, which currently sets bits based on static
-! topography information used in wall_flags_static_0
-! 
+! Introduction of wall_flags_total_0, which currently sets bits based on static topography
+! information used in wall_flags_static_0
+!
 ! 4329 2019-12-10 15:46:36Z motisi
 ! Renamed wall_flags_0 to wall_flags_static_0
-! 
+!
 ! 4310 2019-11-26 19:01:28Z suehring
-! Remove dt_indoor from namelist input. The indoor model is an hourly-based 
-! model, calling it more/less often lead to inaccurate results.
-! 
+! Remove dt_indoor from namelist input. The indoor model is an hourly-based model, calling it
+! more/less often lead to inaccurate results.
+!
 ! 4299 2019-11-22 10:13:38Z suehring
-! Output of indoor temperature revised (to avoid non-defined values within 
-! buildings)
-! 
+! Output of indoor temperature revised (to avoid non-defined values within buildings)
+!
 ! 4267 2019-10-16 18:58:49Z suehring
 ! Bugfix in initialization, some indices to access building_pars where wrong.
 ! Introduction of seasonal parameters.
-! 
+!
 ! 4246 2019-09-30 09:27:52Z pavelkrc
-! 
-! 
+!
+!
 ! 4242 2019-09-27 12:59:10Z suehring
 ! Bugfix in array index
-! 
+!
 ! 4238 2019-09-25 16:06:01Z suehring
 ! - Bugfix in determination of minimum facade height and in location message
 ! - Bugfix, avoid division by zero
-! - Some optimization 
-! 
+! - Some optimization
+!
 ! 4227 2019-09-10 18:04:34Z gronemeier
 ! implement new palm_date_time_mod
@@ -72,13 +72,12 @@
 ! 4209 2019-09-02 12:00:03Z suehring
 ! - Bugfix in initialization of indoor temperature
-! - Prescibe default indoor temperature in case it is not given in the 
-!   namelist input
+! - Prescibe default indoor temperature in case it is not given in the namelist input
 !
 ! 4182 2019-08-21 14:37:54Z scharf
 ! Corrected "Former revisions" section
-! 
+!
 ! 4148 2019-08-08 11:26:00Z suehring
-! Bugfix in case of non grid-resolved buildings. Further, vertical grid spacing
-! is now considered at the correct level.  
+! Bugfix in case of non grid-resolved buildings. Further, vertical grid spacing is now considered at
+! the correct level.
 ! - change calculation of a_m and c_m
 ! - change calculation of u-values (use h_es in building array)
@@ -93,22 +92,22 @@
 !   in building array
 ! - change calculation of q_waste_heat
-! - bugfix in averaging mean indoor temperature 
-! 
+! - bugfix in averaging mean indoor temperature
+!
 ! 3759 2019-02-21 15:53:45Z suehring
 ! - Calculation of total building volume
 ! - Several bugfixes
 ! - Calculation of building height revised
-! 
+!
 ! 3745 2019-02-15 18:57:56Z suehring
 ! - remove building_type from module
-! - initialize parameters for each building individually instead of a bulk 
-!   initializaion with  identical building type for all
+! - initialize parameters for each building individually instead of a bulk initializaion with
+!   identical building type for all
 ! - output revised
 ! - add missing _wp
 ! - some restructuring of variables in building data structure
-! 
+!
 ! 3744 2019-02-15 18:38:58Z suehring
 ! Some interface calls moved to module_interface + cleanup
-! 
+!
 ! 3469 2018-10-30 20:05:07Z kanani
 ! Initial revision (tlang, suehring, kanani, srissman)!
@@ -125,13 +124,14 @@
 ! Description:
 ! ------------
-!> <Description of the new module>
 !> Module for Indoor Climate Model (ICM)
 !> The module is based on the DIN EN ISO 13790 with simplified hour-based procedure.
 !> This model is a equivalent circuit diagram of a three-point RC-model (5R1C).
-!> This module differ between indoor-air temperature an average temperature of indoor surfaces which make it prossible to determine thermal comfort
-!> the heat transfer between indoor and outdoor is simplified 
-
+!> This module differs between indoor-air temperature an average temperature of indoor surfaces which make it prossible to determine
+!> thermal comfort
+!> the heat transfer between indoor and outdoor is simplified
+
+!> @todo Many statement comments that are given as doxygen comments need to be changed to normal comments
 !> @todo Replace window_area_per_facade by %frac(1,m) for window
-!> @todo emissivity change for window blinds if solar_protection_on=1 
+!> @todo emissivity change for window blinds if solar_protection_on=1
 
 !> @note Do we allow use of integer flags, or only logical flags? (concerns e.g. cooling_on, heating_on)
@@ -139,25 +139,24 @@
 !>
 !> @bug  <Enter known bugs here>
-!------------------------------------------------------------------------------!
- MODULE indoor_model_mod 
-
-    USE arrays_3d,                                                             &
-        ONLY:  ddzw,                                                           &
-               dzw,                                                            &
+!--------------------------------------------------------------------------------------------------!
+ MODULE indoor_model_mod
+
+    USE arrays_3d,                                                                                 &
+        ONLY:  ddzw,                                                                               &
+               dzw,                                                                                &
                pt
 
-    USE control_parameters,                                                    &
+    USE control_parameters,                                                                        &
         ONLY:  initializing_actions
 
     USE kinds
-    
-    USE netcdf_data_input_mod,                                                 &
+
+    USE netcdf_data_input_mod,                                                                     &
         ONLY:  building_id_f, building_type_f
 
-    USE palm_date_time_mod,                                                    &
-        ONLY:  get_date_time, northward_equinox, seconds_per_hour,             &
-               southward_equinox
-
-    USE surface_mod,                                                           &
+    USE palm_date_time_mod,                                                                        &
+        ONLY:  get_date_time, northward_equinox, seconds_per_hour, southward_equinox
+
+    USE surface_mod,                                                                               &
         ONLY:  surf_usm_h, surf_usm_v
 
@@ -170,6 +169,6 @@
 
        INTEGER(iwp) ::  id                                !< building ID
+       INTEGER(iwp) ::  kb_max                            !< highest vertical index of a building
        INTEGER(iwp) ::  kb_min                            !< lowest vertical index of a building
-       INTEGER(iwp) ::  kb_max                            !< highest vertical index of a building
        INTEGER(iwp) ::  num_facades_per_building_h = 0    !< total number of horizontal facades elements
        INTEGER(iwp) ::  num_facades_per_building_h_l = 0  !< number of horizontal facade elements on local subdomain
@@ -179,17 +178,17 @@
 
        INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  l_v            !< index array linking surface-element orientation index
-                                                                  !< for vertical surfaces with building 
+                                                                  !< for vertical surfaces with building
        INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  m_h            !< index array linking surface-element index for
                                                                   !< horizontal surfaces with building
-       INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  m_v            !< index array linking surface-element index for 
+       INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  m_v            !< index array linking surface-element index for
                                                                   !< vertical surfaces with building
-       INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  num_facade_h   !< number of horizontal facade elements per buidling 
+       INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  num_facade_h   !< number of horizontal facade elements per buidling
                                                                   !< and height level
        INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  num_facade_v   !< number of vertical facades elements per buidling
                                                                   !< and height level
-                                                                 
+
 
        LOGICAL ::  on_pe = .FALSE.   !< flag indicating whether a building with certain ID is on local subdomain
-       
+
        REAL(wp) ::  air_change_high       !< [1/h] air changes per time_utc_hour
        REAL(wp) ::  air_change_low        !< [1/h] air changes per time_utc_hour
@@ -199,14 +198,15 @@
        REAL(wp) ::  factor_a              !< [-] Dynamic parameters specific effective surface according to Table 12; 2.5
                                           !< (very light, light and medium), 3.0 (heavy), 3.5 (very heavy)
-       REAL(wp) ::  factor_c              !< [J/(m2 K)] Dynamic parameters inner heatstorage according to Table 12; 80000 
+       REAL(wp) ::  factor_c              !< [J/(m2 K)] Dynamic parameters inner heatstorage according to Table 12; 80000
                                           !< (very light), 110000 (light), 165000 (medium), 260000 (heavy), 370000 (very heavy)
        REAL(wp) ::  f_c_win               !< [-] shading factor
        REAL(wp) ::  fapf                  !< [m2/m2] floor area per facade
        REAL(wp) ::  g_value_win           !< [-] SHGC factor
-       REAL(wp) ::  h_es                  !< [W/(m2 K)] surface-related heat transfer coefficient between extern and surface 
+       REAL(wp) ::  h_es                  !< [W/(m2 K)] surface-related heat transfer coefficient between extern and surface
        REAL(wp) ::  height_cei_con        !< [m] ceiling construction heigth
        REAL(wp) ::  height_storey         !< [m] storey heigth
        REAL(wp) ::  params_waste_heat_c   !< [-] anthropogenic heat outputs for cooling e.g. 1.33 for KKM with COP = 3
-       REAL(wp) ::  params_waste_heat_h   !< [-] anthropogenic heat outputs for heating e.g. 1 - 0.9 = 0.1 for combustion with eta = 0.9 or -2 for WP with COP = 3
+       REAL(wp) ::  params_waste_heat_h   !< [-] anthropogenic heat outputs for heating e.g. 1 - 0.9 = 0.1 for combustion with
+                                          !< eta = 0.9 or -2 for WP with COP = 3
        REAL(wp) ::  phi_c_max             !< [W] Max. Cooling capacity (negative)
        REAL(wp) ::  phi_h_max             !< [W] Max. Heating capacity (positive)
@@ -229,5 +229,5 @@
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  vol_frac   !< fraction of local on total building volume, height dependent
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  vpf        !< building volume volume per facade element, height dependent
-       
+
     END TYPE build
 
@@ -237,4 +237,20 @@
 !
 !-- Declare all global variables within the module
+
+    REAL(wp), PARAMETER ::  dt_indoor = 3600.0_wp                  !< [s] time interval for indoor-model application, fixed to
+                                                                   !< 3600.0 due to model requirements
+    REAL(wp), PARAMETER ::  h_is                     = 3.45_wp     !< [W/(m2 K)] surface-related heat transfer coefficient between
+                                                                   !< surface and air (chap. 7.2.2.2)
+    REAL(wp), PARAMETER ::  h_ms                     = 9.1_wp      !< [W/(m2 K)] surface-related heat transfer coefficient between
+                                                                   !< component and surface (chap. 12.2.2)
+    REAL(wp), PARAMETER ::  params_f_f               = 0.3_wp      !< [-] frame ratio chap. 8.3.2.1.1 for buildings with mostly
+                                                                   !< cooling 2.0_wp
+    REAL(wp), PARAMETER ::  params_f_w               = 0.9_wp      !< [-] correction factor (fuer nicht senkrechten Stahlungseinfall
+                                                                   !< DIN 4108-2 chap.8, (hier konstant, keine WinkelabhÃ€ngigkeit)
+    REAL(wp), PARAMETER ::  params_f_win             = 0.5_wp      !< [-] proportion of window area, Database A_win aus
+                                                                   !< Datenbank 27 window_area_per_facade_percent
+    REAL(wp), PARAMETER ::  params_solar_protection  = 300.0_wp    !< [W/m2] chap. G.5.3.1 sun protection closed, if the radiation
+                                                                   !< on facade exceeds this value
+
     INTEGER(iwp) ::  cooling_on              !< Indoor cooling flag (0=off, 1=on)
     INTEGER(iwp) ::  heating_on              !< Indoor heating flag (0=off, 1=on)
@@ -242,5 +258,4 @@
     INTEGER(iwp) ::  solar_protection_on     !< Solar protection on
 
-    REAL(wp), PARAMETER ::  dt_indoor = 3600.0_wp    !< [s] time interval for indoor-model application, fixed to 3600.0 due to model requirements
 
     REAL(wp) ::  a_m                                 !< [m2] the effective mass-related area
@@ -251,12 +266,13 @@
     REAL(wp) ::  h_t_1                               !< [W/K] Heat transfer coefficient auxiliary variable 1
     REAL(wp) ::  h_t_2                               !< [W/K] Heat transfer coefficient auxiliary variable 2
-    REAL(wp) ::  h_t_3                               !< [W/K] Heat transfer coefficient auxiliary variable 3 
-    REAL(wp) ::  h_t_wm                              !< [W/K] Heat transfer coefficient of the emmision (got with h_t_ms the thermal mass)
+    REAL(wp) ::  h_t_3                               !< [W/K] Heat transfer coefficient auxiliary variable 3
+    REAL(wp) ::  h_t_es                              !< [W/K] heat transfer coefficient of doors, windows, curtain walls and
+                                                     !< glazed walls (assumption: thermal mass=0)
     REAL(wp) ::  h_t_is                              !< [W/K] thermal coupling conductance (Thermischer Kopplungsleitwert)
     REAL(wp) ::  h_t_ms                              !< [W/K] Heat transfer conductance term (got with h_t_wm the thermal mass)
     REAL(wp) ::  h_t_wall                            !< [W/K] heat transfer coefficient of opaque components (assumption: got all
                                                      !< thermal mass) contains of h_t_wm and h_t_ms
-    REAL(wp) ::  h_t_es                              !< [W/K] heat transfer coefficient of doors, windows, curtain walls and 
-                                                     !< glazed walls (assumption: thermal mass=0)
+    REAL(wp) ::  h_t_wm                              !< [W/K] Heat transfer coefficient of the emmision (got with h_t_ms the
+                                                     !< thermal mass)
     REAL(wp) ::  h_v                                 !< [W/K] heat transfer of ventilation
     REAL(wp) ::  indoor_volume_per_facade            !< [m3] indoor air volume per facade element
@@ -264,30 +280,31 @@
     REAL(wp) ::  net_sw_in                           !< [W/m2] net short-wave radiation
     REAL(wp) ::  phi_hc_nd                           !< [W] heating demand and/or cooling demand
-    REAL(wp) ::  phi_hc_nd_10                        !< [W] heating demand and/or cooling demand for heating or cooling 
+    REAL(wp) ::  phi_hc_nd_10                        !< [W] heating demand and/or cooling demand for heating or cooling
     REAL(wp) ::  phi_hc_nd_ac                        !< [W] actual heating demand and/or cooling demand
     REAL(wp) ::  phi_hc_nd_un                        !< [W] unlimited heating demand and/or cooling demand which is necessary to
-                                                     !< reach the demanded required temperature (heating is positive, 
-                                                     !< cooling is negative) 
+                                                     !< reach the demanded required temperature (heating is positive,
+                                                     !< cooling is negative)
     REAL(wp) ::  phi_ia                              !< [W] internal air load = internal loads * 0.5, Eq. (C.1)
     REAL(wp) ::  phi_m                               !< [W] mass specific thermal load (internal and external)
     REAL(wp) ::  phi_mtot                            !< [W] total mass specific thermal load (internal and external)
     REAL(wp) ::  phi_sol                             !< [W] solar loads
-    REAL(wp) ::  phi_st                              !< [W] mass specific thermal load implied non thermal mass 
+    REAL(wp) ::  phi_st                              !< [W] mass specific thermal load implied non thermal mass
     REAL(wp) ::  q_wall_win                          !< [W/m2]heat flux from indoor into wall/window
     REAL(wp) ::  q_waste_heat                        !< [W/m2]waste heat, sum of waste heat over the roof to Palm
-                                                     
+
     REAL(wp) ::  q_c_m                               !< [W] Energy of thermal storage mass specific thermal load for internal
                                                      !< and external heatsources (for energy bilanz)
-    REAL(wp) ::  q_c_st                              !< [W] Energy of thermal storage mass specific thermal load implied non thermal mass (for energy bilanz)
+    REAL(wp) ::  q_c_st                              !< [W] Energy of thermal storage mass specific thermal load implied non
+                                                     !< thermal mass (for energy bilanz)
     REAL(wp) ::  q_int                               !< [W] Energy of internal air load (for energy bilanz)
     REAL(wp) ::  q_sol                               !< [W] Energy of solar (for energy bilanz)
     REAL(wp) ::  q_trans                             !< [W] Energy of transmission (for energy bilanz)
     REAL(wp) ::  q_vent                              !< [W] Energy of ventilation (for energy bilanz)
-                                                     
+
     REAL(wp) ::  schedule_d                          !< [-] activation for internal loads (low or high + low)
     REAL(wp) ::  skip_time_do_indoor = 0.0_wp        !< [s] Indoor model is not called before this time
     REAL(wp) ::  theta_air                           !< [degree_C] air temperature of the RC-node
     REAL(wp) ::  theta_air_0                         !< [degree_C] air temperature of the RC-node in equilibrium
-    REAL(wp) ::  theta_air_10                        !< [degree_C] air temperature of the RC-node from a heating capacity 
+    REAL(wp) ::  theta_air_10                        !< [degree_C] air temperature of the RC-node from a heating capacity
                                                      !< of 10 W/m2
     REAL(wp) ::  theta_air_ac                        !< [degree_C] actual room temperature after heating/cooling
